﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace RPGTest
{
    // マップオブジェクトクラス
    class MapObject
    {
        // マップオブジェクト名称
        protected string name;
        public string Name
        {
            set
            {
                name = value;
            }
            get
            {
                return name;
            }
        }

        // 画像情報
        protected Texture2D image;
        protected string asset;

        // 位置情報
        protected Vector2 position;
        public Vector2 Position
        {
            set
            {
                position = value;
            }
            get
            {
                return position;
            }
        }
        protected Vector2 origin;

        // シーン情報
        protected Scene scene;
        public Scene Scene
        {
            set
            {
                scene = value;
            }
            get
            {
                return scene;
            }
        }

        // シーン画像情報
        protected Texture2D sceneImage;
        protected string sceneAsset;

        // コンストラクタ
        public MapObject()
        {
        }

        public MapObject(string name, string asset, Scene scene, string sceneAsset)
        {
            // 初期化
            this.name = name;
            this.asset = asset;
            this.scene = scene;
            this.sceneAsset = sceneAsset;
            origin = new Vector2(0, 30);
        }

        // マップオブジェクト画像の呼出
        public void Load(ContentManager content)
        {
            image = content.Load<Texture2D>(asset);
        }

        // マップオブジェクト画像の表示
        public void Draw(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(image, position, null, Color.White, 0, origin, 1, SpriteEffects.None, position.Y / 450);
        }

        // シーン画像の呼出
        public void LoadScene(ContentManager content)
        {
            sceneImage = content.Load<Texture2D>(sceneAsset);
        }

        // シーン画像の表示
        public void DrawScene(SpriteBatch spriteBatch)
        {
            spriteBatch.Draw(sceneImage, Vector2.Zero, Color.White);
        }
    }
}
